﻿Type=StaticCode
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub ChangeBitmapColors(Bmp As Bitmap) As Bitmap

	Dim PixelsLoop            As Int
		
	Dim BE                    As BitmapExtended
	
	Dim BmpWidth              As Int = BE.getWidth(Bmp)
	Dim BmpHeight             As Int = BE.getHeight(Bmp)
	Dim BmpSize               As Int = (BmpWidth * BmpHeight)
	
	Dim BmpPixels(BmpSize)    As Int
	
	Dim CurrColor             As Int
	Dim PrevColor             As Int = 0
	
	Dim OutColor              As Int = 0

	
    BE.Initialize("")
	BE.getPixels(Bmp, BmpPixels, 0, BmpWidth, 0, 0, BmpWidth, BmpHeight)


#If Debug	
	Log("BmpSize:" &BmpSize &"  BmpPizels Length: " &BmpPixels.Length &"  BmpWidth:" &BmpWidth &"  BmpHeight:" &BmpHeight)
#end if	

	For PixelsLoop = 0 To BmpSize-1
#If Debug	
	    If (PixelsLoop Mod 10000) = 0 Then Log(PixelsLoop &" of " &BmpSize)
#end if

		CurrColor    = BmpPixels(PixelsLoop)       '  Get Current Color

        '------------------------------------------------------------------------------------------------
		'  We are not doing anything with Black or White there does not seem to be any savings
		'     and 
		'------------------------------------------------------------------------------------------------
		If CurrColor = 0xFFFFFFFF OR CurrColor = 0x00FFFFFF Then Continue    '  If White just leave it		
		If CurrColor = 0xFF000000 OR CurrColor = 0x00000000 Then Continue    '  If Black just leave it

				
		If CurrColor = PrevColor Then              '  If we are processing the same color as last time
		   BmpPixels(PixelsLoop) = OutColor        '  Already have the Optimized color just use it
		   Continue
		End If
				
		PrevColor = CurrColor                      ' Save Current  Color
        OutColor  = ConvertColor(CurrColor)		   ' Get Optimized Color
		
	    BmpPixels(PixelsLoop) = OutColor           ' Set Optimized Color
	Next
	    

    BE.setPixels(Bmp, BmpPixels, 0, BmpWidth, 0, 0, BmpWidth, BmpHeight)
	
	Return Bmp
End Sub


Sub GetARGB(Color As Int) As Int()    ' 0 = Alpha, 1 = Red, 2 = Green, 3 = Blue
    Dim res(4) As Int
    res(0) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff000000), 24)
    res(1) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff0000), 16)
    res(2) = Bit.UnsignedShiftRight(Bit.AND(Color, 0xff00), 8)
    res(3) = Bit.AND(Color, 0xff)
    Return res
End Sub


Sub ConvertColor(ColorIn As Int) As Int
    Dim ARGBColor() As Int = GetARGB(ColorIn)
	
	Dim ARGBLoop    As Int 
	
	For ARGBLoop = 1 To ARGBColor.Length-1	
#If _16Colors_	
        ARGBColor(ARGBLoop) = Floor(ARGBColor(ARGBLoop) / 16) * 16
#End If

#If _08Colors_	
        ARGBColor(ARGBLoop) = Floor(ARGBColor(ARGBLoop) / 32) * 32
#End If
    Next
	
	Return Colors.ARGB(255, ARGBColor(1), ARGBColor(2), ARGBColor(3))    
End Sub